import ("music.lib");

//**** définit un indicer qui va permettre de lire une table ****
// durée en echantillons 
// quand le trig vaut 1 : reset l'indicer à zero
// indicer varie de 0 à 1 (samples) en dur echantillons et reste à 1 jusqu'à nouveau trig

indicer(dur, trig) = I ~ _ : /(dur) : max(0)
	with {
			I(p) = if(trig, 0, min(dur, p+1));		
	};
	
// nouvelle fonction functTab pour lire une table pendant une durée dur, contenu signal
// functTab(bpf, low, high, dur, trig) = rdtable(100, bpf(time), 100);// : *(high - low) + low ;
// functTab(bpf, low, high, dur, trig) = rdtable(100, bpf(time), int(100 * indicer(dur, trig))) : *(high - low) + low ;

ifunctTab(bpf, low, high, dur, trig) = s1 * (1 - d) + s2 *d : *(high - low) + low 
	with {
			phase = 100 * indicer(dur, trig) ;
			i = int(phase) ;
			d = decimal(phase);
			s1 = rdtable(101, bpf(time), i);
			s2 = rdtable(101, bpf(time), i+1);
		};
		
		
multiFunctTab(selecteur, low, high, dur, trig) = 
	if (selecteur == 0, ifunctTab(bpf9, low, high, dur, trig),
		if (selecteur == 1, ifunctTab(bpf10, low, high, dur, trig),
		if (selecteur == 2, ifunctTab(bpf11, low, high, dur, trig),
		if (selecteur == 3, ifunctTab(bpf12, low, high, dur, trig),
		if (selecteur == 4, ifunctTab(bpf13, low, high, dur, trig),
		if (selecteur == 5, ifunctTab(bpf14, low, high, dur, trig),
		if (selecteur == 6, ifunctTab(bpf15, low, high, dur, trig),
		if (selecteur == 7, ifunctTab(bpf16, low, high, dur, trig),
		ifunctTab(bpf17, low, high, dur, trig)))))))));
		
// pour trouver la valeur de y en fonction de x
segment(x0, y0, x1, y1, xc, yc) = xc, 
	if((xc >= x0) & (xc <= x1), y0 + (y1 - y0)*(xc -x0)/(x1 - x0), yc);

// 
initseg(x) = x, 0;

// 
endseg(x,y) = y;

// on définit la fonction "if"	
if(c, t, e) = select2(c, e, t);

// définir des bpf :

bpf9 = initseg :         
	segment( 0.00 , 1.00 , 25.00 , 0.25 ):
	segment( 25.00 , 0.25 , 50.00 , 0.10 ):
	segment( 50.00 , 0.10 , 75.00 , 0.05 ):
	segment( 75.00 , 0.05 , 100.00 , 0.00 ):endseg ;
        
bpf10 = initseg :         
	segment( 0.00 , 0.50 , 20.00 , 1.00 ):
	segment( 20.00 , 1.00 , 50.00 , 0.10 ):
	segment( 50.00 , 0.10 , 75.00 , 0.02 ):
	segment( 75.00 , 0.02 , 100.00 , 0.00 ):endseg ;
        
bpf11 = initseg :         
	segment( 0.00 , 0.00 , 10.00 , 0.02 ):
	segment( 10.00 , 0.02 , 15.00 , 0.10 ):
	segment( 15.00 , 0.10 , 25.00 , 0.50 ):
	segment( 25.00 , 0.50 , 30.00 , 0.95 ):
	segment( 30.00 , 0.95 , 33.00 , 1.00 ):
	segment( 33.00 , 1.00 , 85.00 , 0.95 ):
	segment( 85.00 , 0.95 , 90.00 , 0.90 ):
	segment( 90.00 , 0.90 , 95.00 , 0.05 ):
	segment( 95.00 , 0.05 , 100.00 , 0.00 ):endseg ;
        
bpf12 = initseg :         
	segment( 0.00 , 0.00 , 10.00 , 0.02 ):
	segment( 10.00 , 0.02 , 15.00 , 0.10 ):
	segment( 15.00 , 0.10 , 25.00 , 0.50 ):
	segment( 25.00 , 0.50 , 30.00 , 0.95 ):
	segment( 30.00 , 0.95 , 33.00 , 1.00 ):
	segment( 33.00 , 1.00 , 100.00 , 0.95 ):endseg ;
        
bpf13 = initseg :         
	segment( 0.00 , 0.00 , 13.00 , 0.50 ):
	segment( 13.00 , 0.50 , 30.00 , 1.00 ):
	segment( 30.00 , 1.00 , 60.00 , 0.20 ):
	segment( 60.00 , 0.20 , 75.00 , 0.04 ):
	segment( 75.00 , 0.04 , 100.00 , 0.00 ):endseg ;
        
bpf14 = initseg :         
	segment( 0.00 , 1.00 , 12.00 , 0.75 ):
	segment( 12.00 , 0.75 , 25.00 , 1.00 ):
	segment( 25.00 , 1.00 , 50.00 , 0.25 ):
	segment( 50.00 , 0.25 , 75.00 , 0.05 ):
	segment( 75.00 , 0.05 , 100.00 , 0.00 ):endseg ;
        
bpf15 = initseg :         
	segment( 0.00 , 1.00 , 5.00 , 0.10 ):
	segment( 5.00 , 0.10 , 10.00 , 0.02 ):
	segment( 10.00 , 0.02 , 25.00 , 0.00 ):
	segment( 25.00 , 0.00 , 100.00 , 0.00 ):endseg ;
        
bpf16 = initseg :         
	segment( 0.00 , 0.00 , 15.00 , 0.10 ):
	segment( 15.00 , 0.10 , 30.00 , 0.50 ):
	segment( 30.00 , 0.50 , 40.00 , 0.95 ):
	segment( 40.00 , 0.95 , 50.00 , 1.00 ):
	segment( 50.00 , 1.00 , 60.00 , 0.96 ):
	segment( 60.00 , 0.96 , 70.00 , 0.50 ):
	segment( 70.00 , 0.50 , 85.00 , 0.10 ):
	segment( 85.00 , 0.10 , 100.00 , 0.00 ):endseg ;
        
bpf17 = initseg :         
	segment( 0.00 , 1.00 , 11.00 , 0.50 ):
	segment( 11.00 , 0.50 , 25.00 , 0.25 ):
	segment( 25.00 , 0.25 , 50.00 , 0.10 ):
	segment( 50.00 , 0.10 , 75.00 , 0.05 ):
	segment( 75.00 , 0.05 , 100.00 , 0.00 ):endseg ;

// synthèse FM

fmfm (trig, dur, amp, freqc, transp, indxbeg, indxend, scfreqm, selamp, selindx, att) = 
	indicer(att, trig) * multiFunctTab(selamp, 0.0, amp, dur, trig) * 
	osci(freqc * transp + 
	multiFunctTab(selindx, indxend, indxbeg, dur, trig) *
	freqc * scfreqm * transp * osci(freqc * scfreqm * transp)) ;

// process = fm(1, 200, 3, 4, 5) ;
process = fmfm ;


