//-----------------------------------------------------
//
// Code generated with Faust 0.9.10 (http://faust.grame.fr)
//-----------------------------------------------------
/* link with  */
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <math.h>
#include <errno.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <assert.h>
#include <string>
#include <vector>
#include <map>
#include <math.h>

#ifdef __APPLE__
#include <Carbon/Carbon.h>
#include <unistd.h>
#endif

using namespace std ;

// There is a bug with powf() when cross compiling with mingw
// the following macro avoid the problem
#ifdef WIN32
#define powf(x,y) pow(x,y)
#define expf(x) exp(x)
#endif

// On Intel set FZ (Flush to Zero) and DAZ (Denormals Are Zero)
// flags to avoid costly denormals
#ifdef __SSE__
    #include <xmmintrin.h>
    #ifdef __SSE2__
        #define AVOIDDENORMALS _mm_setcsr(_mm_getcsr() | 0x8040)
    #else
        #define AVOIDDENORMALS _mm_setcsr(_mm_getcsr() | 0x8000)
    #endif
#else
    #define AVOIDDENORMALS 
#endif

struct Meta : map<const char*, const char*>
{
    void declare (const char* key, const char* value) { (*this)[key]=value; }
};
	
#ifdef __GNUC__

//-------------------------------------------------------------------
// Generic min and max using gcc extensions
//-------------------------------------------------------------------

#define max(x,y) (((x)>(y)) ? (x) : (y))
#define min(x,y) (((x)<(y)) ? (x) : (y))

//abs(x) should be already predefined

#else

//-------------------------------------------------------------------
// Generic min and max using c++ inline
//-------------------------------------------------------------------

inline int 		max (unsigned int a, unsigned int b) { return (a>b) ? a : b; }
inline int 		max (int a, int b) 			{ return (a>b) ? a : b; }

inline long 	max (long a, long b) 		{ return (a>b) ? a : b; }
inline long 	max (int a, long b) 		{ return (a>b) ? a : b; }
inline long 	max (long a, int b) 		{ return (a>b) ? a : b; }

inline float 	max (float a, float b) 		{ return (a>b) ? a : b; }
inline float 	max (int a, float b) 		{ return (a>b) ? a : b; }
inline float 	max (float a, int b) 		{ return (a>b) ? a : b; }
inline float 	max (long a, float b) 		{ return (a>b) ? a : b; }
inline float 	max (float a, long b) 		{ return (a>b) ? a : b; }

inline double 	max (double a, double b) 	{ return (a>b) ? a : b; }
inline double 	max (int a, double b) 		{ return (a>b) ? a : b; }
inline double 	max (double a, int b) 		{ return (a>b) ? a : b; }
inline double 	max (long a, double b) 		{ return (a>b) ? a : b; }
inline double 	max (double a, long b) 		{ return (a>b) ? a : b; }
inline double 	max (float a, double b) 	{ return (a>b) ? a : b; }
inline double 	max (double a, float b) 	{ return (a>b) ? a : b; }


inline int 		min (int a, int b) 			{ return (a<b) ? a : b; }

inline long 	min (long a, long b) 		{ return (a<b) ? a : b; }
inline long 	min (int a, long b) 		{ return (a<b) ? a : b; }
inline long 	min (long a, int b) 		{ return (a<b) ? a : b; }

inline float 	min (float a, float b) 		{ return (a<b) ? a : b; }
inline float 	min (int a, float b) 		{ return (a<b) ? a : b; }
inline float 	min (float a, int b) 		{ return (a<b) ? a : b; }
inline float 	min (long a, float b) 		{ return (a<b) ? a : b; }
inline float 	min (float a, long b) 		{ return (a<b) ? a : b; }

inline double 	min (double a, double b) 	{ return (a<b) ? a : b; }
inline double 	min (int a, double b) 		{ return (a<b) ? a : b; }
inline double 	min (double a, int b) 		{ return (a<b) ? a : b; }
inline double 	min (long a, double b) 		{ return (a<b) ? a : b; }
inline double 	min (double a, long b) 		{ return (a<b) ? a : b; }
inline double 	min (float a, double b) 	{ return (a<b) ? a : b; }
inline double 	min (double a, float b) 	{ return (a<b) ? a : b; }
		
#endif

// abs is now predefined
//template<typename T> T abs (T a)			{ return (a<T(0)) ? -a : a; }


inline int		lsr (int x, int n)			{ return int(((unsigned int)x) >> n); }

inline int int2pow2 (int x)	{ int r=0; while ((1<<r)<x) r++; return r; }


/******************************************************************************
*******************************************************************************

							       VECTOR INTRINSICS

*******************************************************************************
*******************************************************************************/



/******************************************************************************
*******************************************************************************

								USER INTERFACE

*******************************************************************************
*******************************************************************************/

class UI
{
		bool fStopped;
		
	public:
			
		UI() : fStopped(false) {}
		virtual ~UI() {}
		
		virtual void addButton(const char* label, float* zone) = 0;
		virtual void addToggleButton(const char* label, float* zone) = 0;
		virtual void addCheckButton(const char* label, float* zone) = 0;
		virtual void addVerticalSlider(const char* label, float* zone, float init, float min, float max, float step) = 0;
		virtual void addHorizontalSlider(const char* label, float* zone, float init, float min, float max, float step) = 0;
		virtual void addNumEntry(const char* label, float* zone, float init, float min, float max, float step) = 0;
		
		virtual void addNumDisplay(const char* label, float* zone, int precision) = 0;
		virtual void addTextDisplay(const char* label, float* zone, char* names[], float min, float max) = 0;
		virtual void addHorizontalBargraph(const char* label, float* zone, float min, float max) = 0;
		virtual void addVerticalBargraph(const char* label, float* zone, float min, float max) = 0;
		
		virtual void openFrameBox(const char* label) = 0;
		virtual void openTabBox(const char* label) = 0;
		virtual void openHorizontalBox(const char* label) = 0;
		virtual void openVerticalBox(const char* label) = 0;
		virtual void closeBox() = 0;
		
		virtual void run() {};
		
		void stop()		{ fStopped = true; }
		bool stopped() 	{ return fStopped; }
        
        virtual void declare(float* zone, const char* key, const char* value) {}
};


/******************************************************************************
*******************************************************************************

								FAUST DSP

*******************************************************************************
*******************************************************************************/



//----------------------------------------------------------------
//  definition du processeur de signal
//----------------------------------------------------------------
			
class dsp {

	 protected:
	 
		int fSamplingFreq;
		
	 public:
	 
		dsp() {}
		virtual int getNumInputs() 										= 0;
		virtual int getNumOutputs() 									= 0;
		virtual void buildUserInterface(UI* interface) 					= 0;
		virtual void init(int samplingRate) 							= 0;
	 	virtual void compute(int len, float** inputs, float** outputs) 	= 0;
};


#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif  

typedef long double quad;

class mydsp : public dsp{
  private:
	class SIG0 {
	  private:
		int 	fSamplingFreq;
		float 	S13[2];
		int 	iRec1[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S13[0] = 0;
			for (int i=0; i<2; i++) iRec1[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S9[2];
				float 	S10[2];
				float 	S11[2];
				float 	S12[2];
				iRec1[0] = (1 + iRec1[1]);
				int iTemp1 = (iRec1[0] - 1);
				S13[1] = (1.0f + (9.090909e-02f * (0 - (0.5f * iTemp1))));
				S12[0] = S13[int(((iTemp1 >= 0.0f) & (iTemp1 <= 11.0f)))];
				S12[1] = (0.5f + (7.142857e-02f * (0 - (0.25f * (iRec1[0] - 12.0f)))));
				S11[0] = S12[int(((iTemp1 >= 11.0f) & (iTemp1 <= 25.0f)))];
				S11[1] = (0.25f + (4.000000e-02f * (0 - (0.15f * (iRec1[0] - 26.0f)))));
				S10[0] = S11[int(((iTemp1 >= 25.0f) & (iTemp1 <= 50.0f)))];
				S10[1] = (0.1f + (4.000000e-02f * (0 - (5.000000e-02f * (iRec1[0] - 51.0f)))));
				S9[0] = S10[int(((iTemp1 >= 50.0f) & (iTemp1 <= 75.0f)))];
				S9[1] = (5.000000e-02f + (4.000000e-02f * (0 - (5.000000e-02f * (iRec1[0] - 76.0f)))));
				output[i] = S9[int(((iTemp1 >= 75.0f) & (iTemp1 <= 100.0f)))];
				// post processing
				iRec1[1] = iRec1[0];
			}
		}
	};


	class SIG1 {
	  private:
		int 	fSamplingFreq;
		float 	S22[2];
		int 	iRec3[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S22[0] = 0;
			for (int i=0; i<2; i++) iRec3[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S15[2];
				float 	S16[2];
				float 	S17[2];
				float 	S18[2];
				float 	S19[2];
				float 	S20[2];
				float 	S21[2];
				iRec3[0] = (1 + iRec3[1]);
				int iTemp11 = (iRec3[0] - 1);
				S22[1] = (6.666667e-03f * iTemp11);
				S21[0] = S22[int(((iTemp11 >= 0.0f) & (iTemp11 <= 15.0f)))];
				S21[1] = (0.1f + (2.666667e-02f * (iRec3[0] - 16.0f)));
				S20[0] = S21[int(((iTemp11 >= 15.0f) & (iTemp11 <= 30.0f)))];
				S20[1] = (0.5f + (4.500000e-02f * (iRec3[0] - 31.0f)));
				S19[0] = S20[int(((iTemp11 >= 30.0f) & (iTemp11 <= 40.0f)))];
				S19[1] = (0.95f + (5.000000e-03f * (iRec3[0] - 41.0f)));
				S18[0] = S19[int(((iTemp11 >= 40.0f) & (iTemp11 <= 50.0f)))];
				S18[1] = (1.0f + (0.1f * (0 - (4.000000e-02f * (iRec3[0] - 51.0f)))));
				S17[0] = S18[int(((iTemp11 >= 50.0f) & (iTemp11 <= 60.0f)))];
				S17[1] = (0.96f + (0.1f * (0 - (0.46f * (iRec3[0] - 61.0f)))));
				S16[0] = S17[int(((iTemp11 >= 60.0f) & (iTemp11 <= 70.0f)))];
				S16[1] = (0.5f + (6.666667e-02f * (0 - (0.4f * (iRec3[0] - 71.0f)))));
				S15[0] = S16[int(((iTemp11 >= 70.0f) & (iTemp11 <= 85.0f)))];
				S15[1] = (0.1f + (6.666667e-02f * (0 - (0.1f * (iRec3[0] - 86.0f)))));
				output[i] = S15[int(((iTemp11 >= 85.0f) & (iTemp11 <= 100.0f)))];
				// post processing
				iRec3[1] = iRec3[0];
			}
		}
	};


	class SIG2 {
	  private:
		int 	fSamplingFreq;
		float 	S23[2];
		float 	S26[2];
		int 	iRec4[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S26[0] = 0;
			for (int i=0; i<2; i++) iRec4[i] = 0;
			S23[1] = 0.0f;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S24[2];
				float 	S25[2];
				iRec4[0] = (1 + iRec4[1]);
				int iTemp14 = (iRec4[0] - 1);
				S26[1] = (1.0f + (0.2f * (0 - (0.9f * iTemp14))));
				S25[0] = S26[int(((iTemp14 >= 0.0f) & (iTemp14 <= 5.0f)))];
				S25[1] = (0.1f + (0.2f * (0 - (8.000000e-02f * (iRec4[0] - 6.0f)))));
				S24[0] = S25[int(((iTemp14 >= 5.0f) & (iTemp14 <= 10.0f)))];
				S24[1] = (2.000000e-02f + (6.666667e-02f * (0 - (2.000000e-02f * (iRec4[0] - 11.0f)))));
				S23[0] = S24[int(((iTemp14 >= 10.0f) & (iTemp14 <= 25.0f)))];
				output[i] = S23[int(((iTemp14 >= 25.0f) & (iTemp14 <= 100.0f)))];
				// post processing
				iRec4[1] = iRec4[0];
			}
		}
	};


	class SIG3 {
	  private:
		int 	fSamplingFreq;
		float 	S31[2];
		int 	iRec5[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S31[0] = 0;
			for (int i=0; i<2; i++) iRec5[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S27[2];
				float 	S28[2];
				float 	S29[2];
				float 	S30[2];
				iRec5[0] = (1 + iRec5[1]);
				int iTemp16 = (iRec5[0] - 1);
				S31[1] = (1.0f + (8.333333e-02f * (0 - (0.25f * iTemp16))));
				S30[0] = S31[int(((iTemp16 >= 0.0f) & (iTemp16 <= 12.0f)))];
				S30[1] = (0.75f + (1.923077e-02f * (iRec5[0] - 13.0f)));
				S29[0] = S30[int(((iTemp16 >= 12.0f) & (iTemp16 <= 25.0f)))];
				S29[1] = (1.0f + (4.000000e-02f * (0 - (0.75f * (iRec5[0] - 26.0f)))));
				S28[0] = S29[int(((iTemp16 >= 25.0f) & (iTemp16 <= 50.0f)))];
				S28[1] = (0.25f + (4.000000e-02f * (0 - (0.2f * (iRec5[0] - 51.0f)))));
				S27[0] = S28[int(((iTemp16 >= 50.0f) & (iTemp16 <= 75.0f)))];
				S27[1] = (5.000000e-02f + (4.000000e-02f * (0 - (5.000000e-02f * (iRec5[0] - 76.0f)))));
				output[i] = S27[int(((iTemp16 >= 75.0f) & (iTemp16 <= 100.0f)))];
				// post processing
				iRec5[1] = iRec5[0];
			}
		}
	};


	class SIG4 {
	  private:
		int 	fSamplingFreq;
		float 	S36[2];
		int 	iRec6[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S36[0] = 0;
			for (int i=0; i<2; i++) iRec6[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S32[2];
				float 	S33[2];
				float 	S34[2];
				float 	S35[2];
				iRec6[0] = (1 + iRec6[1]);
				int iTemp18 = (iRec6[0] - 1);
				S36[1] = (3.846154e-02f * iTemp18);
				S35[0] = S36[int(((iTemp18 >= 0.0f) & (iTemp18 <= 13.0f)))];
				S35[1] = (0.5f + (2.941176e-02f * (iRec6[0] - 14.0f)));
				S34[0] = S35[int(((iTemp18 >= 13.0f) & (iTemp18 <= 30.0f)))];
				S34[1] = (1.0f + (3.333333e-02f * (0 - (0.8f * (iRec6[0] - 31.0f)))));
				S33[0] = S34[int(((iTemp18 >= 30.0f) & (iTemp18 <= 60.0f)))];
				S33[1] = (0.2f + (6.666667e-02f * (0 - (0.16f * (iRec6[0] - 61.0f)))));
				S32[0] = S33[int(((iTemp18 >= 60.0f) & (iTemp18 <= 75.0f)))];
				S32[1] = (4.000000e-02f * (1.0f + (0 - (4.000000e-02f * (iRec6[0] - 76.0f)))));
				output[i] = S32[int(((iTemp18 >= 75.0f) & (iTemp18 <= 100.0f)))];
				// post processing
				iRec6[1] = iRec6[0];
			}
		}
	};


	class SIG5 {
	  private:
		int 	fSamplingFreq;
		float 	S42[2];
		int 	iRec7[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S42[0] = 0;
			for (int i=0; i<2; i++) iRec7[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S37[2];
				float 	S38[2];
				float 	S39[2];
				float 	S40[2];
				float 	S41[2];
				iRec7[0] = (1 + iRec7[1]);
				int iTemp20 = (iRec7[0] - 1);
				S42[1] = (2.000000e-03f * iTemp20);
				S41[0] = S42[int(((iTemp20 >= 0.0f) & (iTemp20 <= 10.0f)))];
				S41[1] = (2.000000e-02f + (1.600000e-02f * (iRec7[0] - 11.0f)));
				S40[0] = S41[int(((iTemp20 >= 10.0f) & (iTemp20 <= 15.0f)))];
				S40[1] = (0.1f + (4.000000e-02f * (iRec7[0] - 16.0f)));
				S39[0] = S40[int(((iTemp20 >= 15.0f) & (iTemp20 <= 25.0f)))];
				S39[1] = (0.5f + (9.000000e-02f * (iRec7[0] - 26.0f)));
				S38[0] = S39[int(((iTemp20 >= 25.0f) & (iTemp20 <= 30.0f)))];
				S38[1] = (0.95f + (1.666667e-02f * (iRec7[0] - 31.0f)));
				S37[0] = S38[int(((iTemp20 >= 30.0f) & (iTemp20 <= 33.0f)))];
				S37[1] = (1.0f + (1.492537e-02f * (0 - (5.000000e-02f * (iRec7[0] - 34.0f)))));
				output[i] = S37[int(((iTemp20 >= 33.0f) & (iTemp20 <= 100.0f)))];
				// post processing
				iRec7[1] = iRec7[0];
			}
		}
	};


	class SIG6 {
	  private:
		int 	fSamplingFreq;
		float 	S51[2];
		int 	iRec8[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S51[0] = 0;
			for (int i=0; i<2; i++) iRec8[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S43[2];
				float 	S44[2];
				float 	S45[2];
				float 	S46[2];
				float 	S47[2];
				float 	S48[2];
				float 	S49[2];
				float 	S50[2];
				iRec8[0] = (1 + iRec8[1]);
				int iTemp22 = (iRec8[0] - 1);
				S51[1] = (2.000000e-03f * iTemp22);
				S50[0] = S51[int(((iTemp22 >= 0.0f) & (iTemp22 <= 10.0f)))];
				S50[1] = (2.000000e-02f + (1.600000e-02f * (iRec8[0] - 11.0f)));
				S49[0] = S50[int(((iTemp22 >= 10.0f) & (iTemp22 <= 15.0f)))];
				S49[1] = (0.1f + (4.000000e-02f * (iRec8[0] - 16.0f)));
				S48[0] = S49[int(((iTemp22 >= 15.0f) & (iTemp22 <= 25.0f)))];
				S48[1] = (0.5f + (9.000000e-02f * (iRec8[0] - 26.0f)));
				S47[0] = S48[int(((iTemp22 >= 25.0f) & (iTemp22 <= 30.0f)))];
				S47[1] = (0.95f + (1.666667e-02f * (iRec8[0] - 31.0f)));
				S46[0] = S47[int(((iTemp22 >= 30.0f) & (iTemp22 <= 33.0f)))];
				S46[1] = (1.0f + (1.923077e-02f * (0 - (5.000000e-02f * (iRec8[0] - 34.0f)))));
				S45[0] = S46[int(((iTemp22 >= 33.0f) & (iTemp22 <= 85.0f)))];
				S45[1] = (0.95f + (0.2f * (0 - (5.000000e-02f * (iRec8[0] - 86.0f)))));
				S44[0] = S45[int(((iTemp22 >= 85.0f) & (iTemp22 <= 90.0f)))];
				S44[1] = (0.9f + (0.2f * (0 - (0.85f * (iRec8[0] - 91.0f)))));
				S43[0] = S44[int(((iTemp22 >= 90.0f) & (iTemp22 <= 95.0f)))];
				S43[1] = (5.000000e-02f + (0.2f * (0 - (5.000000e-02f * (iRec8[0] - 96.0f)))));
				output[i] = S43[int(((iTemp22 >= 95.0f) & (iTemp22 <= 100.0f)))];
				// post processing
				iRec8[1] = iRec8[0];
			}
		}
	};


	class SIG7 {
	  private:
		int 	fSamplingFreq;
		float 	S55[2];
		int 	iRec9[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S55[0] = 0;
			for (int i=0; i<2; i++) iRec9[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S52[2];
				float 	S53[2];
				float 	S54[2];
				iRec9[0] = (1 + iRec9[1]);
				int iTemp24 = (iRec9[0] - 1);
				S55[1] = (0.5f + (2.500000e-02f * iTemp24));
				S54[0] = S55[int(((iTemp24 >= 0.0f) & (iTemp24 <= 20.0f)))];
				S54[1] = (1.0f + (3.333333e-02f * (0 - (0.9f * (iRec9[0] - 21.0f)))));
				S53[0] = S54[int(((iTemp24 >= 20.0f) & (iTemp24 <= 50.0f)))];
				S53[1] = (0.1f + (4.000000e-02f * (0 - (8.000000e-02f * (iRec9[0] - 51.0f)))));
				S52[0] = S53[int(((iTemp24 >= 50.0f) & (iTemp24 <= 75.0f)))];
				S52[1] = (2.000000e-02f + (4.000000e-02f * (0 - (2.000000e-02f * (iRec9[0] - 76.0f)))));
				output[i] = S52[int(((iTemp24 >= 75.0f) & (iTemp24 <= 100.0f)))];
				// post processing
				iRec9[1] = iRec9[0];
			}
		}
	};


	class SIG8 {
	  private:
		int 	fSamplingFreq;
		float 	S59[2];
		int 	iRec10[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			S59[0] = 0;
			for (int i=0; i<2; i++) iRec10[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				float 	S56[2];
				float 	S57[2];
				float 	S58[2];
				iRec10[0] = (1 + iRec10[1]);
				int iTemp26 = (iRec10[0] - 1);
				S59[1] = (1.0f + (4.000000e-02f * (0 - (0.75f * iTemp26))));
				S58[0] = S59[int(((iTemp26 >= 0.0f) & (iTemp26 <= 25.0f)))];
				S58[1] = (0.25f + (4.000000e-02f * (0 - (0.15f * (iRec10[0] - 26.0f)))));
				S57[0] = S58[int(((iTemp26 >= 25.0f) & (iTemp26 <= 50.0f)))];
				S57[1] = (0.1f + (4.000000e-02f * (0 - (5.000000e-02f * (iRec10[0] - 51.0f)))));
				S56[0] = S57[int(((iTemp26 >= 50.0f) & (iTemp26 <= 75.0f)))];
				S56[1] = (5.000000e-02f + (4.000000e-02f * (0 - (5.000000e-02f * (iRec10[0] - 76.0f)))));
				output[i] = S56[int(((iTemp26 >= 75.0f) & (iTemp26 <= 100.0f)))];
				// post processing
				iRec10[1] = iRec10[0];
			}
		}
	};


	class SIG9 {
	  private:
		int 	fSamplingFreq;
		int 	iRec13[2];
	  public:
		int getNumInputs() 	{ return 0; }
		int getNumOutputs() 	{ return 1; }
		void init(int samplingFreq) {
			fSamplingFreq = samplingFreq;
			for (int i=0; i<2; i++) iRec13[i] = 0;
		}
		void fill (int count, float output[]) {
			for (int i=0; i<count; i++) {
				iRec13[0] = (1 + iRec13[1]);
				output[i] = sinf((9.587380e-05f * float((iRec13[0] - 1))));
				// post processing
				iRec13[1] = iRec13[0];
			}
		}
	};


	int 	S0[2];
	int 	iRec0[2];
	static float 	ftbl0[101];
	float 	S14[2];
	float 	fRec2[2];
	static float 	ftbl1[101];
	static float 	ftbl2[101];
	static float 	ftbl3[101];
	static float 	ftbl4[101];
	static float 	ftbl5[101];
	static float 	ftbl6[101];
	static float 	ftbl7[101];
	static float 	ftbl8[101];
	float 	fConst0;
	float 	fRec12[2];
	static float 	ftbl9[65537];
	float 	fRec11[2];
  public:
	static void metadata(Meta* m) 	{ 
	}

	virtual int getNumInputs() 	{ return 11; }
	virtual int getNumOutputs() 	{ return 1; }
	static void classInit(int samplingFreq) {
		SIG0 sig0;
		sig0.init(samplingFreq);
		sig0.fill(101,ftbl0);
		SIG1 sig1;
		sig1.init(samplingFreq);
		sig1.fill(101,ftbl1);
		SIG2 sig2;
		sig2.init(samplingFreq);
		sig2.fill(101,ftbl2);
		SIG3 sig3;
		sig3.init(samplingFreq);
		sig3.fill(101,ftbl3);
		SIG4 sig4;
		sig4.init(samplingFreq);
		sig4.fill(101,ftbl4);
		SIG5 sig5;
		sig5.init(samplingFreq);
		sig5.fill(101,ftbl5);
		SIG6 sig6;
		sig6.init(samplingFreq);
		sig6.fill(101,ftbl6);
		SIG7 sig7;
		sig7.init(samplingFreq);
		sig7.fill(101,ftbl7);
		SIG8 sig8;
		sig8.init(samplingFreq);
		sig8.fill(101,ftbl8);
		SIG9 sig9;
		sig9.init(samplingFreq);
		sig9.fill(65537,ftbl9);
	}
	virtual void instanceInit(int samplingFreq) {
		fSamplingFreq = samplingFreq;
		S0[1] = 0;
		for (int i=0; i<2; i++) iRec0[i] = 0;
		S14[1] = 0;
		for (int i=0; i<2; i++) fRec2[i] = 0;
		fConst0 = (1.0f / float(fSamplingFreq));
		for (int i=0; i<2; i++) fRec12[i] = 0;
		for (int i=0; i<2; i++) fRec11[i] = 0;
	}
	virtual void init(int samplingFreq) {
		classInit(samplingFreq);
		instanceInit(samplingFreq);
	}
	virtual void buildUserInterface(UI* interface) {
		interface->openVerticalBox("fmfm3");
		interface->closeBox();
	}
	virtual void compute (int count, FAUSTFLOAT** input, FAUSTFLOAT** output) {
		FAUSTFLOAT* input0 = input[0];
		FAUSTFLOAT* input1 = input[1];
		FAUSTFLOAT* input2 = input[2];
		FAUSTFLOAT* input3 = input[3];
		FAUSTFLOAT* input4 = input[4];
		FAUSTFLOAT* input5 = input[5];
		FAUSTFLOAT* input6 = input[6];
		FAUSTFLOAT* input7 = input[7];
		FAUSTFLOAT* input8 = input[8];
		FAUSTFLOAT* input9 = input[9];
		FAUSTFLOAT* input10 = input[10];
		FAUSTFLOAT* output0 = output[0];
		for (int i=0; i<count; i++) {
			S0[0] = min(100, (1 + iRec0[1]));
			int iTemp0 = int((float)input0[i]);
			iRec0[0] = S0[iTemp0];
			float 	S1[2];
			float 	S2[2];
			float 	S3[2];
			float 	S4[2];
			float 	S5[2];
			float 	S6[2];
			float 	S7[2];
			float 	S8[2];
			float fTemp2 = (float)input1[i];
			S14[0] = min(fTemp2, (1 + fRec2[1]));
			fRec2[0] = S14[iTemp0];
			float fTemp3 = (100 * max(0, (fRec2[0] / fTemp2)));
			int iTemp4 = int(fTemp3);
			float fTemp5 = floorf(fTemp3);
			float fTemp6 = ((1 + fTemp5) - fTemp3);
			int iTemp7 = (1 + iTemp4);
			float fTemp8 = (fTemp3 - fTemp5);
			float fTemp9 = ((fTemp8 * ftbl0[iTemp7]) + (fTemp6 * ftbl0[iTemp4]));
			float fTemp10 = (float)input2[i];
			S8[0] = (fTemp10 * fTemp9);
			float fTemp12 = ((fTemp8 * ftbl1[iTemp7]) + (fTemp6 * ftbl1[iTemp4]));
			S8[1] = (fTemp10 * fTemp12);
			float fTemp13 = (float)input8[i];
			S7[0] = S8[int((fTemp13 == 7))];
			float fTemp15 = ((fTemp8 * ftbl2[iTemp7]) + (fTemp6 * ftbl2[iTemp4]));
			S7[1] = (fTemp10 * fTemp15);
			S6[0] = S7[int((fTemp13 == 6))];
			float fTemp17 = ((fTemp8 * ftbl3[iTemp7]) + (fTemp6 * ftbl3[iTemp4]));
			S6[1] = (fTemp10 * fTemp17);
			S5[0] = S6[int((fTemp13 == 5))];
			float fTemp19 = ((fTemp8 * ftbl4[iTemp7]) + (fTemp6 * ftbl4[iTemp4]));
			S5[1] = (fTemp10 * fTemp19);
			S4[0] = S5[int((fTemp13 == 4))];
			float fTemp21 = ((fTemp8 * ftbl5[iTemp7]) + (fTemp6 * ftbl5[iTemp4]));
			S4[1] = (fTemp10 * fTemp21);
			S3[0] = S4[int((fTemp13 == 3))];
			float fTemp23 = ((fTemp8 * ftbl6[iTemp7]) + (fTemp6 * ftbl6[iTemp4]));
			S3[1] = (fTemp10 * fTemp23);
			S2[0] = S3[int((fTemp13 == 2))];
			float fTemp25 = ((fTemp8 * ftbl7[iTemp7]) + (fTemp6 * ftbl7[iTemp4]));
			S2[1] = (fTemp10 * fTemp25);
			S1[0] = S2[int((fTemp13 == 1))];
			float fTemp27 = ((fTemp8 * ftbl8[iTemp7]) + (ftbl8[iTemp4] * fTemp6));
			S1[1] = (fTemp10 * fTemp27);
			float 	S60[2];
			float 	S61[2];
			float 	S62[2];
			float 	S63[2];
			float 	S64[2];
			float 	S65[2];
			float 	S66[2];
			float 	S67[2];
			float fTemp28 = (float)input6[i];
			float fTemp29 = ((float)input5[i] - fTemp28);
			S67[0] = (fTemp28 + (fTemp29 * fTemp9));
			S67[1] = (fTemp28 + (fTemp29 * fTemp12));
			float fTemp30 = (float)input9[i];
			S66[0] = S67[int((fTemp30 == 7))];
			S66[1] = (fTemp28 + (fTemp29 * fTemp15));
			S65[0] = S66[int((fTemp30 == 6))];
			S65[1] = (fTemp28 + (fTemp29 * fTemp17));
			S64[0] = S65[int((fTemp30 == 5))];
			S64[1] = (fTemp28 + (fTemp29 * fTemp19));
			S63[0] = S64[int((fTemp30 == 4))];
			S63[1] = (fTemp28 + (fTemp29 * fTemp21));
			S62[0] = S63[int((fTemp30 == 3))];
			S62[1] = (fTemp28 + (fTemp29 * fTemp23));
			S61[0] = S62[int((fTemp30 == 2))];
			S61[1] = (fTemp28 + (fTemp29 * fTemp25));
			S60[0] = S61[int((fTemp30 == 1))];
			S60[1] = (fTemp28 + (fTemp29 * fTemp27));
			float fTemp31 = (float)input7[i];
			float fTemp32 = ((float)input3[i] * (float)input4[i]);
			float fTemp33 = ((fConst0 * (fTemp32 * fTemp31)) + fRec12[1]);
			fRec12[0] = (fTemp33 - floorf(fTemp33));
			float fTemp34 = (65536.0f * fRec12[0]);
			int iTemp35 = int(fTemp34);
			float fTemp36 = ftbl9[iTemp35];
			float fTemp37 = ((fConst0 * (fTemp32 * (1 + ((fTemp31 * (fTemp36 + ((ftbl9[(1 + iTemp35)] - fTemp36) * (fTemp34 - floorf(fTemp34))))) * S60[int((fTemp30 == 0))])))) + fRec11[1]);
			fRec11[0] = (fTemp37 - floorf(fTemp37));
			float fTemp38 = (65536.0f * fRec11[0]);
			int iTemp39 = int(fTemp38);
			float fTemp40 = ftbl9[iTemp39];
			output0[i] = (FAUSTFLOAT)(((fTemp40 + ((ftbl9[(1 + iTemp39)] - fTemp40) * (fTemp38 - floorf(fTemp38)))) * S1[int((fTemp13 == 0))]) * max(0, (1.000000e-02f * iRec0[0])));
			// post processing
			fRec11[1] = fRec11[0];
			fRec12[1] = fRec12[0];
			fRec2[1] = fRec2[0];
			iRec0[1] = iRec0[0];
		}
	}
};


float 	mydsp::ftbl0[101];
float 	mydsp::ftbl1[101];
float 	mydsp::ftbl2[101];
float 	mydsp::ftbl3[101];
float 	mydsp::ftbl4[101];
float 	mydsp::ftbl5[101];
float 	mydsp::ftbl6[101];
float 	mydsp::ftbl7[101];
float 	mydsp::ftbl8[101];
float 	mydsp::ftbl9[65537];

				
/* Faust code wrapper ------- */

#include "ext.h"
#include "z_dsp.h"
#include <string.h>

#define ASSIST_INLET 	1  		/* should be defined somewhere ?? */
#define ASSIST_OUTLET 	2		/* should be defined somewhere ?? */

class mspUI;


/*--------------------------------------------------------------------------*/
typedef struct faust
{
	t_pxobject m_ob;
	t_atom *m_seen,*m_want;
	short m_where;
	void** args;
	mspUI* dspUI;
	mydsp* dsp;
} t_faust;

void *faust_class;

/*--------------------------------------------------------------------------*/
class mspUIObject {

	protected:
		
		string fLabel;
		float* fZone;
		
		float range(float min, float max, float val) {return (val < min) ? min : (val > max) ? max : val;}
	
	public:
			
		mspUIObject(const char* label, float* zone):fLabel(label),fZone(zone) {}
		virtual ~mspUIObject() {}
		
		virtual void SetValue(double f) {*fZone = range(0.0,1.0,f);}
		virtual void toString(char* buffer) {}
		virtual string GetName() {return fLabel;}
};

/*--------------------------------------------------------------------------*/
class mspToggleButton : public mspUIObject {
	
	public:	
	
		mspToggleButton(const char* label, float* zone):mspUIObject(label,zone) {}
		virtual ~mspToggleButton() {}
				
		void toString(char* buffer)
		{
		#ifdef WIN32
            sprintf(buffer, "ToggleButton(float): %s", fLabel.c_str());
		#else
			std::sprintf(buffer, "ToggleButton(float): %s", fLabel.c_str());
		#endif	
		}
};

/*--------------------------------------------------------------------------*/
class mspCheckButton : public mspUIObject {
	
	public:
	
		mspCheckButton(const char* label, float* zone):mspUIObject(label,zone) {}
		virtual ~mspCheckButton() {}
		
		void toString(char* buffer)
		{
		#ifdef WIN32
            sprintf(buffer, "CheckButton(float): %s", fLabel.c_str());
		#else
			std::sprintf(buffer, "CheckButton(float): %s", fLabel.c_str());
		#endif
		}
};

/*--------------------------------------------------------------------------*/
class mspButton : public mspUIObject {
	
	public:
	
		mspButton(const char* label, float* zone):mspUIObject(label,zone) {}
		virtual ~mspButton() {}		
		
		void toString(char* buffer)
		{
		#ifdef WIN32
            sprintf(buffer, "Button(float): %s", fLabel.c_str());
		#else
			std::sprintf(buffer, "Button(float): %s", fLabel.c_str());
		#endif
		}	
};

/*--------------------------------------------------------------------------*/
class mspSlider : public mspUIObject{

	private:
	
		float fInit;
		float fMin;
		float fMax;
		float fStep;
	
	public:	
	
		mspSlider(const char* label, float* zone, float init, float min, float max, float step)
			:mspUIObject(label,zone),fInit(init),fMin(min),fMax(max),fStep(step) {}
		virtual ~mspSlider() {}	
		
		void toString(char* buffer)
		{
		#ifdef WIN32
            sprintf(buffer, "Slider(float): %s [%.1f:%.1f:%.1f]", fLabel.c_str(), fMin, fInit, fMax);
		#else
			std::sprintf(buffer, "Slider(float): %s [%.1f:%.1f:%.1f]", fLabel.c_str(), fMin, fInit, fMax);
		#endif
		}
		
		void SetValue(double f) {*fZone = range(fMin,fMax,f);}
};

/*--------------------------------------------------------------------------*/
class mspUI : public UI
{
	private:
	
		map<string,mspUIObject*> fUITable;
		
	public:
		typedef map<string,mspUIObject*>::iterator iterator;
			
		mspUI(){}
		virtual ~mspUI() 
		{
			for (iterator iter = fUITable.begin(); iter != fUITable.end(); iter++) 
				delete (iter->second);
   		}
		
		void addButton(const char* label, float* zone) {fUITable[string(label)] = new mspButton(label, zone);}
		
		void addToggleButton(const char* label, float* zone) {fUITable[string(label)] = new mspToggleButton(label, zone);}
		
		void addCheckButton(const char* label, float* zone) {fUITable[string(label)] = new mspCheckButton(label, zone);}
		
		void addVerticalSlider(const char* label, float* zone, float init, float min, float max, float step) 
		{ 	
			fUITable[string(label)] = new mspSlider(label, zone, init, min, max, step);
		}
		
		void addHorizontalSlider(const char* label, float* zone, float init, float min, float max, float step) 
		{
			fUITable[string(label)] = new mspSlider(label, zone, init, min, max, step);
		}
		
		void addNumEntry(const char* label, float* zone, float init, float min, float max, float step)
		{
			fUITable[string(label)] = new mspSlider(label, zone, init, min, max, step);
		}
		
		void openFrameBox(const char* label) {}
		void openTabBox(const char* label) {}
		void openHorizontalBox(const char* label) {}
		void openVerticalBox(const char* label) {}
		void closeBox() {}
		
		void SetValue(string name, double f) 
		{
			if(fUITable.count(name))
				fUITable[name]->SetValue(f);
		}
		iterator begin()	{return fUITable.begin();}
		iterator end()		{return fUITable.end();}
							
		// To be implemented
		void addNumDisplay(const char* label, float* zone, int precision){}
		void addTextDisplay(const char* label, float* zone, char* names[], float min, float max){}
		void addHorizontalBargraph(const char* label, float* zone, float min, float max){}
		void addVerticalBargraph(const char* label, float* zone, float min, float max){}
}; 


//--------------------------------------------------------------------------
void faust_method(t_faust *obj, t_symbol *s, short ac, t_atom *at)
{
	if(ac < 0) return;
    if(at[0].a_type != A_FLOAT) return;
	
    string name = string( (s)->s_name );
    float value = at[0].a_w.w_float;
	
    // lookup du nom dans une std::map<string,mspUIObject *>
    // ou une std::map<string,float *>
    // et affectation de value;	
	obj->dspUI->SetValue(name,value); // doesn't have any effect if name is unknown
}

/*--------------------------------------------------------------------------*/
void *faust_new(t_symbol *s, short ac, t_atom *av)
{
	t_faust *x = (t_faust *)newobject(faust_class);
		
	x->dsp = new mydsp();
	x->dspUI= new mspUI();
	
	x->dsp->init(long(sys_getsr()));
	x->dsp->buildUserInterface(x->dspUI);
	
	x->args = (void**)calloc((x->dsp->getNumInputs()+x->dsp->getNumOutputs())+2, sizeof(void*));
	
	/* Multi in */
	dsp_setup((t_pxobject *)x, x->dsp->getNumInputs());
	
	/* Multi out */
	for (int i = 0; i< x->dsp->getNumOutputs(); i++) 
		outlet_new((t_pxobject *)x, (char*)"signal");
	
	((t_pxobject *)x)->z_misc = Z_NO_INPLACE; // To assure input and output buffers are actually different
	return x;
}			

/*--------------------------------------------------------------------------*/
void faust_assist(t_faust *x, void *b, long msg, long a, char *dst)
{
    if (msg == ASSIST_INLET) {
        if (a == 0) {
            if (x->dsp->getNumInputs() == 0) {
			#ifdef WIN32
                sprintf(dst, "(signal) : Unused Input");
			#else
				std::sprintf(dst, "(signal) : Unused Input");
			#endif
            } else {
			#ifdef WIN32
                sprintf(dst, "(signal) : Audio Input %ld", (a+1));
			#else
				std::sprintf(dst, "(signal) : Audio Input %ld", (a+1));
			#endif
				post((char*)"------------------");
				for (mspUI::iterator it = x->dspUI->begin(); it != x->dspUI->end(); ++it) {
					char param[64];
					it->second->toString(param);
					post(param);
				}
			}
        } else if (a < x->dsp->getNumInputs()) {
		#ifdef WIN32
            sprintf(dst, "(signal) : Audio Input %ld", (a+1));
		#else
			std::sprintf(dst, "(signal) : Audio Input %ld", (a+1));
		#endif
        }
    } else if (msg == ASSIST_OUTLET) {
	#ifdef WIN32
        sprintf(dst, "(signal) : Audio Output %ld", (a+1));
	#else
		std::sprintf(dst, "(signal) : Audio Output %ld", (a+1));
	#endif
    }
}

/*--------------------------------------------------------------------------*/
void faust_free(t_faust *x)
{
	dsp_free((t_pxobject *)x);
	if (x->dsp) delete x->dsp;
	if (x->dspUI) delete x->dspUI;
	if (x->args)free(x->args);
}

/*--------------------------------------------------------------------------*/
t_int *faust_perform(t_int *w)
{
	t_faust* x = (t_faust*) (w[1]);
	long n = w[2];
	int offset = 3;
	AVOIDDENORMALS;
	x->dsp->compute(n, ((float**)&w[offset]), ((float**)&w[offset+x->dsp->getNumInputs()]));
	return (w + (x->dsp->getNumInputs()+x->dsp->getNumOutputs())+2+1);
}

/*--------------------------------------------------------------------------*/
void  faust_dsp(t_faust *x, t_signal **sp, short *count)
{
	x->args[0] = x;
	x->args[1] = (void*)sp[0]->s_n;
	for (int i = 0; i<(x->dsp->getNumInputs()+x->dsp->getNumOutputs()); i++) 
		x->args[i+2] = sp[i]->s_vec;
	dsp_addv(faust_perform, (x->dsp->getNumInputs()+x->dsp->getNumOutputs())+2, x->args);
}

/*--------------------------------------------------------------------------*/
int main()
{
	setup((t_messlist **)&faust_class, (method)faust_new, (method)faust_free, 
		(short)sizeof(t_faust), 0L, A_DEFFLOAT, 0);
   
	dsp *thedsp = new mydsp();
	mspUI *dspUI= new mspUI();
	thedsp->buildUserInterface(dspUI);
	
	// Add the same method for every parameters and use the symbol as a selector 
	// inside thid method
	for (mspUI::iterator it = dspUI->begin(); it != dspUI->end(); ++it) {
		char *name = const_cast<char *>(it->second->GetName().c_str());
		addmess((method)faust_method, name, A_GIMME, 0);
	}
	
	addmess((method)faust_dsp, (char*)"dsp", A_CANT, 0);
	addmess((method)faust_assist, (char*)"assist", A_CANT, 0);
	dsp_initclass();
    
    delete(dspUI);
    delete(thedsp);
	post((char*)"Faust DSP object");
	return 0;
}




